StarObject Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | Private Member Functions | List of all members
StarObject Class Reference

an object corresponding to an OLE directory More...

`#include <StarObject.hxx>`

Inheritance diagram for StarObject:

## Public Member Functions
| StarObject (char const *passwd, std::shared_ptr< STOFFOLEParser > &oleParser, std::shared_ptr< STOFFOLEParser::OleDirectory > &directory)
| constructor More...
virtual | ~StarObject ()
| destructor More...
bool | parse ()
| try to parse data More...
STOFFDocument::Kind | getDocumentKind () const
| returns the document kind More...
char const * | getPassword () const
| returns the document password (the password given by the user) More...
std::shared_ptr< STOFFOLEParser::OleDirectory > | getOLEDirectory ()
| returns the object directory More...
std::shared_ptr< StarAttributeManager > | getAttributeManager ()
| returns the attribute manager More...
std::shared_ptr< StarFormatManager > | getFormatManager ()
| returns the format manager More...
librevenge::RVNGPropertyList const & | getMetaData () const
| returns the meta data (filled by readSfxDocumentInformation) More...
librevenge::RVNGString | getUserNameMetaData (int i) const
| returns the ith user meta data More...
void | cleanPools ()
| clean each pool More...
std::shared_ptr< StarItemPool > | getNewItemPool (StarItemPool::Type type)
| returns a new item pool for this document More...
std::shared_ptr< StarItemPool > | findItemPool (StarItemPool::Type type, bool isInside)
| check if a pool corresponding to a given type is opened if so returned it. More...
std::shared_ptr< StarItemPool > | getCurrentPool (bool onlyInside=true)
| returns the current all/inside pool More...
bool | readPersistData (StarZone &zone, long endPos)
| try to read persist data More...
bool | readSfxStyleSheets (STOFFInputStreamPtr input, std::string const &name)
| try to read a spreadshet style zone: SfxStyleSheets More...
bool | readItemSet (StarZone &zone, std::vector< STOFFVec2i > const &limits, long endPos, StarItemSet &itemSet, StarItemPool *pool=nullptr, bool isDirect=false)
| try to read a list of item More...

## Protected Member Functions
bool | readPersistElements (STOFFInputStreamPtr input, std::string const &name)
| the "persist elements" small ole: the list of object More...
bool | readSfxDocumentInformation (STOFFInputStreamPtr input, std::string const &name)
| try to read the document information : "SfxDocumentInformation" More...
bool | readSfxPreview (STOFFInputStreamPtr input, std::string const &name)
| try to read the preview : "SfxPreview" More...
bool | readSfxWindows (STOFFInputStreamPtr input, libstoff::DebugFile &ascii)
| try to read the windows information : "SfxWindows" More...
bool | readStarFrameworkConfigFile (STOFFInputStreamPtr input, libstoff::DebugFile &ascii)
| try to read the "Star Framework Config File" More...
bool | readStarFrameworkConfigItem (STOFFEntry &entry, STOFFInputStreamPtr input, libstoff::DebugFile &ascii)
| try to read an item in a "Star Framework Config File" More...
| StarObject (StarObject const &orig, bool duplicateState)
| copy constructor More...

## Protected Attributes
char const * | m_password
| the document password More...
std::shared_ptr< STOFFOLEParser > | m_oleParser
| the ole parser More...
std::shared_ptr< STOFFOLEParser::OleDirectory > | m_directory
| the directory More...
std::shared_ptr< StarObjectInternal::State > | m_state
| the state More...
librevenge::RVNGPropertyList | m_metaData
| the meta data More...

## Private Member Functions
| StarObject (StarObject const &orig)=delete
StarObject & | operator= (StarObject const &orig)=delete

## Detailed Description

an object corresponding to an OLE directory

## Constructor & Destructor Documentation

## ◆ StarObject() [1/3]

StarObject::StarObject | ( | char const * | passwd,
|  | std::shared_ptr< STOFFOLEParser > & | oleParser,
|  | std::shared_ptr< STOFFOLEParser::OleDirectory > & | directory
| ) |  |

constructor

## ◆ ~StarObject()

StarObject::~StarObject | ( |  | ) |
| virtual

destructor

## ◆ StarObject() [2/3]

StarObject::StarObject | ( | StarObject const & | orig,
|  | bool | duplicateState
| ) |  |
| protected

copy constructor

## ◆ StarObject() [3/3]

StarObject::StarObject | ( | StarObject const & | orig | ) |
| privatedelete

## Member Function Documentation

## ◆ cleanPools()

void StarObject::cleanPools | ( |  | ) |

clean each pool

Referenced by StarObjectChart::~StarObjectChart(), StarObjectDraw::~StarObjectDraw(), StarObjectSpreadsheet::~StarObjectSpreadsheet(), and StarObjectText::~StarObjectText().

## ◆ findItemPool()

std::shared_ptr< StarItemPool > StarObject::findItemPool | ( | StarItemPool::Type | type,
|  | bool | isInside
| ) |  |

check if a pool corresponding to a given type is opened if so returned it.

Note
  if isInside is set only look for inside pool

Referenced by StarObjectSmallText::read(), StarObjectSpreadsheet::readSCColumn(), StarObjectChart::readSCHAttributes(), StarObjectSmallGraphic::readSVDRObjectAttrib(), StarObjectSmallGraphic::readSVDRObjectCaption(), StarObjectSmallGraphic::readSVDRObjectCircle(), StarObjectSmallGraphic::readSVDRObjectEdge(), StarObjectSmallGraphic::readSVDRObjectGraph(), StarObjectSmallGraphic::readSVDRObjectMeasure(), StarObjectSmallGraphic::readSVDRObjectPath(), StarObjectSmallText::send(), StarObjectSpreadsheet::sendCell(), StarObjectModel::sendMasterPages(), StarObjectText::sendPages(), StarObjectPageStyle::updatePageSpans(), StarObjectSpreadsheet::updatePageSpans(), StarObjectText::updatePageSpans(), and StarObjectModel::updatePageSpans().

## ◆ getAttributeManager()

std::shared_ptr< StarAttributeManager > StarObject::getAttributeManager | ( |  | ) |

returns the attribute manager

Referenced by StarItemPoolInternal::State::getDefaultAttribute(), and StarItemPool::readStyles().

## ◆ getCurrentPool()

std::shared_ptr< StarItemPool > StarObject::getCurrentPool | ( | bool | onlyInside = `true` | ) |

returns the current all/inside pool

## ◆ getDocumentKind()

STOFFDocument::Kind StarObject::getDocumentKind | ( |  | ) | const

returns the document kind

Referenced by SDAParser::createZones(), SDCParser::createZones(), SDWParser::createZones(), StarObjectText::readDrawingLayer(), StarObjectChart::readSfxStyleSheets(), StarObjectDraw::readSfxStyleSheets(), StarObjectSpreadsheet::readSfxStyleSheets(), StarObjectText::readSfxStyleSheets(), and readSfxStyleSheets().

## ◆ getFormatManager()

std::shared_ptr< StarFormatManager > StarObject::getFormatManager | ( |  | ) |

returns the format manager

Referenced by StarObjectPageStyle::read(), StarObjectSpreadsheet::readCalcDocument(), StarObjectChart::readSCHAttributes(), StarObjectText::readSWContent(), StarObjectText::readSWSection(), StarObjectText::readSWTextZone(), StarObjectText::readWriterDocument(), and StarObjectSpreadsheet::sendCell().

## ◆ getMetaData()

librevenge::RVNGPropertyList const & StarObject::getMetaData | ( |  | ) | const
| inline

returns the meta data (filled by readSfxDocumentInformation)

## ◆ getNewItemPool()

std::shared_ptr< StarItemPool > StarObject::getNewItemPool | ( | StarItemPool::Type | type | ) |

returns a new item pool for this document

Referenced by parse(), StarObjectSmallText::read(), StarObjectSpreadsheet::readCalcDocument(), StarObjectChart::readChartDocument(), StarObjectText::readDrawingLayer(), StarObjectSpreadsheet::readSCColumn(), StarObjectChart::readSCHAttributes(), StarObjectModel::readSdrPage(), StarObjectChart::readSfxStyleSheets(), StarObjectDraw::readSfxStyleSheets(), StarObjectSpreadsheet::readSfxStyleSheets(), StarObjectText::readSfxStyleSheets(), readSfxStyleSheets(), StarObjectSmallGraphic::readSVDRObjectAttrib(), StarObjectSmallGraphic::readSVDRObjectCaption(), StarObjectSmallGraphic::readSVDRObjectCircle(), StarObjectSmallGraphic::readSVDRObjectEdge(), StarObjectSmallGraphic::readSVDRObjectGraph(), and StarObjectSmallGraphic::readSVDRObjectMeasure().

## ◆ getOLEDirectory()

std::shared_ptr< STOFFOLEParser::OleDirectory > StarObject::getOLEDirectory | ( |  | ) |
| inline

returns the object directory

Referenced by StarObjectChart::parse(), StarObjectDraw::parse(), StarObjectMath::parse(), StarObjectSpreadsheet::parse(), and StarObjectText::parse().

## ◆ getPassword()

char const * StarObject::getPassword | ( |  | ) | const
| inline

returns the document password (the password given by the user)

Referenced by StarObjectText::parse(), StarObjectSpreadsheet::readCalcDocument(), StarObjectChart::readChartDocument(), StarObjectDraw::readDrawDocument(), StarObjectText::readDrawingLayer(), StarObjectChart::readSfxStyleSheets(), StarObjectDraw::readSfxStyleSheets(), StarObjectSpreadsheet::readSfxStyleSheets(), StarObjectText::readSfxStyleSheets(), readSfxStyleSheets(), and StarObjectText::readWriterDocument().

## ◆ getUserNameMetaData()

librevenge::RVNGString StarObject::getUserNameMetaData | ( | int | i | ) | const

returns the ith user meta data

## ◆ operator=()

StarObject & StarObject::operator= | ( | StarObject const & | orig | ) |
| privatedelete

## ◆ parse()

bool StarObject::parse | ( |  | ) |

try to parse data

Referenced by StarObjectChart::parse(), StarObjectDraw::parse(), StarObjectMath::parse(), StarObjectSpreadsheet::parse(), and StarObjectText::parse().

## ◆ readItemSet()

bool StarObject::readItemSet | ( | StarZone & | zone,
|  | std::vector< STOFFVec2i > const & | limits,
|  | long | endPos,
|  | StarItemSet & | itemSet,
|  | StarItemPool * | pool = `nullptr`,
|  | bool | isDirect = `false`
| ) |  |

try to read a list of item

Referenced by StarObjectSmallText::read(), StarObjectChart::readSCHAttributes(), and StarItemPool::readStyles().

## ◆ readPersistData()

bool StarObject::readPersistData | ( | StarZone & | zone,
|  | long | endPos
| ) |  |

try to read persist data

Referenced by readPersistElements().

## ◆ readPersistElements()

bool StarObject::readPersistElements | ( | STOFFInputStreamPtr | input,
|  | std::string const & | name
| ) |  |
| protected

the "persist elements" small ole: the list of object

Referenced by parse().

## ◆ readSfxDocumentInformation()

bool StarObject::readSfxDocumentInformation | ( | STOFFInputStreamPtr | input,
|  | std::string const & | name
| ) |  |
| protected

try to read the document information : "SfxDocumentInformation"

Referenced by parse().

## ◆ readSfxPreview()

bool StarObject::readSfxPreview | ( | STOFFInputStreamPtr | input,
|  | std::string const & | name
| ) |  |
| protected

try to read the preview : "SfxPreview"

Referenced by parse().

## ◆ readSfxStyleSheets()

bool StarObject::readSfxStyleSheets | ( | STOFFInputStreamPtr | input,
|  | std::string const & | name
| ) |  |

try to read a spreadshet style zone: SfxStyleSheets

## ◆ readSfxWindows()

bool StarObject::readSfxWindows | ( | STOFFInputStreamPtr | input,
|  | libstoff::DebugFile & | ascii
| ) |  |
| protected

try to read the windows information : "SfxWindows"

Referenced by parse().

## ◆ readStarFrameworkConfigFile()

bool StarObject::readStarFrameworkConfigFile | ( | STOFFInputStreamPtr | input,
|  | libstoff::DebugFile & | ascii
| ) |  |
| protected

try to read the "Star Framework Config File"

Referenced by parse().

## ◆ readStarFrameworkConfigItem()

bool StarObject::readStarFrameworkConfigItem | ( | STOFFEntry & | entry,
|  | STOFFInputStreamPtr | input,
|  | libstoff::DebugFile & | ascii
| ) |  |
| protected

try to read an item in a "Star Framework Config File"

Referenced by readStarFrameworkConfigFile().

## Member Data Documentation

## ◆ m_directory

std::shared_ptr<STOFFOLEParser::OleDirectory> StarObject::m_directory
| protected

the directory

Referenced by getDocumentKind(), getOLEDirectory(), and parse().

## ◆ m_metaData

librevenge::RVNGPropertyList StarObject::m_metaData
| protected

the meta data

Referenced by getMetaData(), and readSfxDocumentInformation().

## ◆ m_oleParser

std::shared_ptr<STOFFOLEParser> StarObject::m_oleParser
| protected

the ole parser

Referenced by StarObjectSmallGraphic::readSVDRObjectOLE(), StarObjectText::readSWGraphNode(), and StarObjectText::readSWOLENode().

## ◆ m_password

char const* StarObject::m_password
| protected

the document password

Referenced by getPassword(), parse(), readPersistElements(), and readSfxPreview().

## ◆ m_state

std::shared_ptr<StarObjectInternal::State> StarObject::m_state
| protected

the state

Referenced by cleanPools(), findItemPool(), getAttributeManager(), getCurrentPool(), getFormatManager(), getNewItemPool(), getUserNameMetaData(), readSfxDocumentInformation(), and StarObject().

The documentation for this class was generated from the following files:

- StarObject.hxx
- StarObject.cxx